﻿package
{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.ColorTransform;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Griffer extends Sprite
	{
		public static var rot:Number = 0;
		public static var activenodes:Number = 0;
		private var theta:Number=0;
		private var blocs:Array;
		private var offsetStep:Number = 1;
		private var ct:ColorTransform;
		public static var mouseFollower:Point;
		public function Griffer()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);	
		}
		private function addedHandler(e:Event):void
		{
			blocs = new Array();
			mouseFollower = new Point(stage.stageWidth / 2, stage.stageHeight / 2);
			graphics.lineStyle(5,0xff0000,0.8);
			//graphics.drawRect(0,stage.stageHeight/2,stage.stageWidth,1);
			stage.addEventListener(MouseEvent.CLICK, clickHandler);
			addEventListener(Event.ENTER_FRAME,enterHandler);
			ct = new ColorTransform(1, 1, 1, 1, 0, 20, -120, 200);
		}
		private function clickHandler(e:MouseEvent):void
		{
			if(activenodes<8){
				var b:Bloc = new Bloc(0);
				b.x = stage.stageWidth/2;
				
				b.y = stage.stageHeight/2;
				
				b.scaleX = b.scaleY = (5 + Math.random()*20)/100;
				if(mouseY>stage.stageHeight/2){b.scaleY*=-1;}
				addChild(b);
				
				activenodes++;
				blocs.push(b);
			}
		}
		private function enterHandler(e:Event):void
		{
			var difX:Number = mouseX - mouseFollower.x;
			var difY:Number = mouseY - mouseFollower.y;
			var dif:Number = Math.sqrt((difX * difX) + (difY * difY));
			mouseFollower.x += difX / 12;
			mouseFollower.y += difY / 12;
			var v:Number =(mouseX-stage.stageWidth/2)/50;
			theta+=v;
			rot=-30*Math.sin(Math.PI / 180 * theta);
			
			for (var i:int; i < blocs.length; i++) {
				blocs[i].rotate(difX / 300, difY / 30);
			}
			
			if(ct.redOffset > 255 || ct.redOffset < -255) {
				offsetStep *= -1;
			}
			ct.redOffset += offsetStep;
			ct.blueOffset += offsetStep;
			ct.greenOffset += offsetStep;
            //this.transform.colorTransform = ct;
		}
	}
}
import flash.display.Sprite;
import flash.utils.clearInterval;
import flash.utils.setInterval;
import flash.display.BlendMode;
import Griffer;
internal class Bloc extends Sprite{
	private var id:uint;
	private var _depth:Number;
	private var color:uint = 0x00ffff;
	private var nextBloc:Bloc;
	private var angle:Number;
	public function Bloc(depth:Number)
	{
		_depth = depth;
		this.graphics.beginFill(this.color,1);
		this.graphics.drawRect(-30,-30,60,60);
		this.graphics.endFill();
		if(_depth<70){id = setInterval(branche,10);}else{Griffer.activenodes--;}
		
	}
	private function branche():void
	{
		clearInterval(id);
		_depth++;
		var b:Bloc = new Bloc(_depth);
		b.y = -45;
		b.scaleX = b.scaleY = b.alpha = 0.98;
		b.rotation = Griffer.rot;
		addChild(b);
		nextBloc = b;
	}
	
	public function rotate(angle:Number, offset:Number):void {
		this.rotation += angle;
		this.angle = angle;
		if(_depth > 1)
			this.y += offset;
		if(nextBloc != null) 
			nextBloc.rotate(this.angle, offset);
			
	}
	
}